// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice

#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__TRAITS_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "marine_sensor_msgs/msg/detail/radar_sector__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'time_increment'
// Member 'scan_time'
#include "builtin_interfaces/msg/detail/duration__traits.hpp"
// Member 'intensities'
#include "marine_sensor_msgs/msg/detail/radar_echo__traits.hpp"

namespace marine_sensor_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RadarSector & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: angle_start
  {
    out << "angle_start: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_start, out);
    out << ", ";
  }

  // member: angle_increment
  {
    out << "angle_increment: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_increment, out);
    out << ", ";
  }

  // member: time_increment
  {
    out << "time_increment: ";
    to_flow_style_yaml(msg.time_increment, out);
    out << ", ";
  }

  // member: scan_time
  {
    out << "scan_time: ";
    to_flow_style_yaml(msg.scan_time, out);
    out << ", ";
  }

  // member: range_min
  {
    out << "range_min: ";
    rosidl_generator_traits::value_to_yaml(msg.range_min, out);
    out << ", ";
  }

  // member: range_max
  {
    out << "range_max: ";
    rosidl_generator_traits::value_to_yaml(msg.range_max, out);
    out << ", ";
  }

  // member: intensities
  {
    if (msg.intensities.size() == 0) {
      out << "intensities: []";
    } else {
      out << "intensities: [";
      size_t pending_items = msg.intensities.size();
      for (auto item : msg.intensities) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RadarSector & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: angle_start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angle_start: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_start, out);
    out << "\n";
  }

  // member: angle_increment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "angle_increment: ";
    rosidl_generator_traits::value_to_yaml(msg.angle_increment, out);
    out << "\n";
  }

  // member: time_increment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_increment:\n";
    to_block_style_yaml(msg.time_increment, out, indentation + 2);
  }

  // member: scan_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scan_time:\n";
    to_block_style_yaml(msg.scan_time, out, indentation + 2);
  }

  // member: range_min
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "range_min: ";
    rosidl_generator_traits::value_to_yaml(msg.range_min, out);
    out << "\n";
  }

  // member: range_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "range_max: ";
    rosidl_generator_traits::value_to_yaml(msg.range_max, out);
    out << "\n";
  }

  // member: intensities
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.intensities.size() == 0) {
      out << "intensities: []\n";
    } else {
      out << "intensities:\n";
      for (auto item : msg.intensities) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RadarSector & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace marine_sensor_msgs

namespace rosidl_generator_traits
{

[[deprecated("use marine_sensor_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const marine_sensor_msgs::msg::RadarSector & msg,
  std::ostream & out, size_t indentation = 0)
{
  marine_sensor_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use marine_sensor_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const marine_sensor_msgs::msg::RadarSector & msg)
{
  return marine_sensor_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<marine_sensor_msgs::msg::RadarSector>()
{
  return "marine_sensor_msgs::msg::RadarSector";
}

template<>
inline const char * name<marine_sensor_msgs::msg::RadarSector>()
{
  return "marine_sensor_msgs/msg/RadarSector";
}

template<>
struct has_fixed_size<marine_sensor_msgs::msg::RadarSector>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marine_sensor_msgs::msg::RadarSector>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marine_sensor_msgs::msg::RadarSector>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__TRAITS_HPP_
